/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: fmprop.cxx,v $
 * $Revision: 1.22 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/

// MARKER(update_precomp.py): autogen include statement, do not remove
#include "precompiled_svx.hxx"

#ifndef _SVX_FMPROP_HRC
#include "fmprop.hrc"
#endif
#include "fmstatic.hxx"

#include <set>

namespace svxform
{
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_NAME,"Name");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CLASSID,"ClassId");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ROWCOUNT,"RowCount");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ROWCOUNTFINAL,"IsRowCountFinal");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FETCHSIZE,"FetchSize");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_VALUE,"Value");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TEXT,"Text");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_LABEL,"Label");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CANINSERT,"CanInsert");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CANUPDATE,"CanUpdate");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CANDELETE,"CanDelete");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_NAVIGATION,"NavigationBarMode");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_HASNAVIGATION,"HasNavigationBar");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CYCLE,"Cycle");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CONTROLSOURCE,"DataField");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ENABLED,"Enabled");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_READONLY,"ReadOnly");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISREADONLY,"IsReadOnly");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FILTER,"Filter");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_AUTOINCREMENT,"IsAutoIncrement");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATAENTRY,"DataEntry");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_WIDTH,"Width");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SEARCHABLE,"IsSearchable");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_MULTILINE,"MultiLine");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TARGET_URL,"TargetURL");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULTCONTROL,"DefaultControl");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_MAXTEXTLEN,"MaxTextLen");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_EDITMASK,"EditMask");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SPIN,"Spin");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATE,"Date");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TIME,"Time");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_STATE,"State");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TRISTATE,"TriState");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_STRINGITEMLIST,"StringItemList");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULT_TEXT,"DefaultText");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULTCHECKED,"DefaultState");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FORMATKEY,"FormatKey");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FORMATSSUPPLIER,"FormatsSupplier");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_LISTSOURCETYPE,"ListSourceType");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_LISTSOURCE,"ListSource");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SELECT_SEQ,"SelectedItems");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_VALUE_SEQ,"ValueItemList");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULT_SELECT_SEQ,"DefaultSelection");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ALIGN,"Align");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULT_DATE,"DefaultDate");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULT_TIME,"DefaultTime");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DEFAULT_VALUE,"DefaultValue");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DECIMAL_ACCURACY,"DecimalAccuracy");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CURSORSOURCE,"DataSelection");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CURSORSOURCETYPE,"DataSelectionType");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FIELDTYPE,"Type");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_REFVALUE,"RefValue");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_VALUEMIN,"ValueMin");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_VALUEMAX,"ValueMax");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_STRICTFORMAT,"StrictFormat");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_LITERALMASK,"LiteralMask");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_VALUESTEP,"ValueStep");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SHOWTHOUSANDSEP,"ShowThousandsSeparator");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CURRENCYSYMBOL,"CurrencySymbol");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATEFORMAT,"DateFormat");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATEMIN,"DateMin");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATEMAX,"DateMax");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATE_SHOW_CENTURY,"DateShowCentury");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TIMEFORMAT, "TimeFormat");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TIMEMIN, "TimeMin");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TIMEMAX,"TimeMax");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_LINECOUNT,"LineCount");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_BOUNDCOLUMN, "BoundColumn");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FONT,"FontDescriptor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_BACKGROUNDCOLOR,"BackgroundColor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TEXTCOLOR,"TextColor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_BORDER,"Border");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DROPDOWN,"Dropdown");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ROWHEIGHT,"RowHeight");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_HELPTEXT, "HelpText");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_HELPURL, "HelpURL");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_RECORDMARKER, "HasRecordMarker");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_BOUNDFIELD, "BoundField");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_EFFECTIVE_VALUE, "EffectiveValue");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_EFFECTIVE_DEFAULT, "EffectiveDefault");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_EFFECTIVE_MIN, "EffectiveMin");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_EFFECTIVE_MAX, "EffectiveMax");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_HIDDEN, "Hidden");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FILTERPROPOSAL, "UseFilterValueProposal");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FIELDSOURCE, "FieldSource");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TABLENAME, "TableName");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FILTERSUPPLIER, "FilterSupplier");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CURRENTFILTER, "CurrentFilter");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SELECTED_FIELDS, "SelectedFields");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SELECTED_TABLES, "SelectedTables");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_THREADSAFE, "ThreadSafe");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISFILTERAPPLIED, "IsFilterApplied");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CONTROLLABEL, "LabelControl");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CURSORCOLOR, "CursorColor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ALWAYSSHOWCURSOR, "AlwaysShowCursor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DISPLAYSYNCHRON, "DisplayIsSynchron");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISMODIFIED, "IsModified");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISNEW, "IsNew");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_PRIVILEGES, "Privileges");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_COMMAND,"Command");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_COMMANDTYPE,"CommandType");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_RESULTSET_CONCURRENCY, "ResultSetConcurrency");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_INSERTONLY, "IgnoreResult");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_RESULTSET_TYPE, "ResultSetType");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ESCAPE_PROCESSING, "EscapeProcessing");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_APPLYFILTER, "ApplyFilter");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISNULLABLE, "IsNullable");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ACTIVECOMMAND, "ActiveCommand");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ISCURRENCY, "IsCurrency");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_URL, "URL");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_ACTIVE_CONNECTION, "ActiveConnection");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_SORT, "Order");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_DATASOURCE, "DataSourceName");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_REALNAME,"RealName");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_CONTROLSOURCEPROPERTY,"DataFieldProperty");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_TEXTLINECOLOR, "TextLineColor");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FONTEMPHASISMARK, "FontEmphasisMark");
	IMPLEMENT_CONSTASCII_USTRING(FM_PROP_FONTRELIEF, "FontRelief");

    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SCROLLVALUE_MIN,             "ScrollValueMin"            );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SCROLLVALUE_MAX,             "ScrollValueMax"            );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_DEFAULT_SCROLLVALUE,         "DefaultScrollValue"        );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_LINEINCREMENT,               "LineIncrement"             );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_BLOCKINCREMENT,              "BlockIncrement"            );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_ORIENTATION,                 "Orientation"               );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_REPEAT,                      "Repeat"                    );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_REPEATDELAY,                 "RepeatDelay"               );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SYMBOLCOLOR,                 "SymbolColor"               );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_VISIBILESIZE,                "VisibleSize"               );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SPINVALUE_MIN,               "SpinValueMin"              );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SPINVALUE_MAX,               "SpinValueMax"              );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_DEFAULT_SPINVALUE,           "DefaultSpinValue"          );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_SPININCREMENT,               "SpinIncrement"             );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_LINEENDFORMAT,               "LineEndFormat"             );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_TOGGLE,                      "Toggle"                    );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_FOCUSONCLICK,                "FocusOnClick"              );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_HIDEINACTIVESELECTION,       "HideInactiveSelection"     );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_VISUALEFFECT,                "VisualEffect"              );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_BORDERCOLOR,                 "BorderColor"               );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_DYNAMIC_CONTROL_BORDER,      "DynamicControlBorder"      );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_CONTROL_BORDER_COLOR_FOCUS,  "ControlBorderColorOnFocus" );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_CONTROL_BORDER_COLOR_MOUSE,  "ControlBorderColorOnHover" );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_CONTROL_BORDER_COLOR_INVALID,"ControlBorderColorOnInvalid" );

    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_BUTTON_TYPE, "ButtonType" );
    IMPLEMENT_CONSTASCII_USTRING( FM_PROP_FORM_OPERATIONS, "FormOperations" );

}	// namespace svxform

